--===============================================================================
--============================ login screen settings ============================
--===============================================================================
-- >>>>>>>>>>>>>>>>>>>> CHOOSE WHETHER TO AUTO LOGIN OR NOT <<<<<<<<<<<<<<<<<<<<<
fastLoginAutoLogin=false
-- >>>>>>>>>>>>>>> ENTER YOUR USERNAME BETWEEN THE QUOTES BELOW <<<<<<<<<<<<<<<<<
fastLoginUser=""
-- >>>>>>>>>>>>>>> ENTER YOUR PASSWORD BETWEEN THE QUOTES BELOW <<<<<<<<<<<<<<<<<
local fastLoginPass=""
--===============================================================================
--========================== character select settings ==========================
--===============================================================================
-- >>>>> CHOOSE WHETHER TO AUTO ENTER THE GAME WORLD WITH THAT CHAR OR NOT <<<<<<
fastLoginAutoEnter=false
-- >>>>>>> ENTER THE NUMBER OF THE CHARACTER YOU WANT TO BE AUTO SELECTED <<<<<<<
fastLoginChrSel=1
-- >>>>>>>> ENTER THE NUMBER OF THE CHANNEL YOU WANT TO BE AUTO SELECTED <<<<<<<<
fastLoginRegSel=1
-- >>>>>>>>> SHOULD WE RELOG IN AFTER RETURNING TO CHARACTER SELECTION <<<<<<<<<<
fastLoginRelog=false
-- >>>>>>> CHOOSE WHETHER TO REMOVE THE ZOOM FROM THE CHAR SELECT OR NOT <<<<<<<<
fastLoginNoZoom=false
--===============================================================================
-- New in game feature: Set LoginNextToon=true at end of your 1-10 scripts when
-- you want to load another character and then log out. This script will then
-- load the next character.
--===============================================================================
--========================== character Acc & Pass  ==============================
--===============================================================================
-- Here is a button map to help with button placement.
--    Account22                                           Account26
--    Account21                                           Account25
--    Account20                                           Account24
--    Account19                                           Account23
--    Account4                                            Account8
--    Account3                                            Account7
--    Account2     Account1      Log In      Account5     Account6
--    Account9     Account10    Account11    Account12    Account13
--    Account14    Account15    Account16    Account17    Account18
--    Account27    Account28    Account29    Account30    Account31
--    Account32    Account33    Account34    Account35    Account36
--    Account37    Account38    Account39    Account40
--===============================================================================

local CustomLogin = {
	Account1 = {	UserName = "EgAccount",	Password = "EgPassword",	},
	Account2 = {	UserName = "",	Password = "",	},
	Account3 = {	UserName = "",	Password = "",	},
	Account4 = {	UserName = "",	Password = "",	},
	Account5 = {	UserName = "",	Password = "",	},
	Account6 = {	UserName = "",	Password = "",	},
	Account7 = {	UserName = "",	Password = "",	},
	Account8 = {	UserName = "",	Password = "",	},
	Account9 = {	UserName = "",	Password = "",	},
	Account10 = {	UserName = "",	Password = "",	},
	Account11 = {	UserName = "",	Password = "",	},
	Account12 = {	UserName = "",	Password = "",	},
	Account13 = {	UserName = "",	Password = "",	},
	Account14 = {	UserName = "",	Password = "",	},
	Account15 = {	UserName = "",	Password = "",	},
	Account16 = {	UserName = "",	Password = "",	},
	Account17 = {	UserName = "",	Password = "",	},
	Account18 = {	UserName = "",	Password = "",	},
    Account19 = {	UserName = "",	Password = "",	},
	Account20 = {	UserName = "",	Password = "",	},
    Account21 = {	UserName = "",	Password = "",	},
    Account22 = {	UserName = "",	Password = "",	},
    Account23 = {	UserName = "",	Password = "",	},
    Account24 = {	UserName = "",	Password = "",	},
    Account25 = {	UserName = "",	Password = "",	},
    Account26 = {	UserName = "",	Password = "",	},
    Account27 = {	UserName = "",	Password = "",	},
    Account28 = {	UserName = "",	Password = "",	},
    Account29 = {	UserName = "",	Password = "",	},
    Account30 = {	UserName = "",	Password = "",	},
    Account31 = {	UserName = "",	Password = "",	},
    Account32 = {	UserName = "",	Password = "",	},
    Account33 = {	UserName = "",	Password = "",	},
    Account34 = {	UserName = "",	Password = "",	},
    Account35 = {	UserName = "",	Password = "",	},
    Account36 = {	UserName = "",	Password = "",	},
    Account37 = {	UserName = "",	Password = "",	},
    Account38 = {	UserName = "",	Password = "",	},
    Account39 = {	UserName = "",	Password = "",	},
    Account40 = {	UserName = "",	Password = "",	},
	}



ACCOUNTLOGIN_FADEIN_TIME1 = 0.001;
ACCOUNTLOGIN_FADEIN_TIME2 = 0.001;
ACCOUNTLOGIN_AGREEMENT = false;
LoginNextToon=false -- Do not change this here. Change it in game to log into next character
AutoLoginAccount=0 -- Do not change this here. Change it in game to log into other account
ChangeCharRelog=false


function AccountLogin_OnShow()
	if ( fastLoginAutoLogin and ( not fastLoginTriedOnce ) ) then
		AccountLoginAccountEdit:SetText(fastLoginUser);
		AccountLoginPasswordEdit:SetFocus();
		AccountLoginPasswordEdit:SetText(fastLoginPass);
		fastLoginTriedOnce=true;
		AccountLogin_Login();
	else
		AccountLoginAccountEdit:SetFocus();
	end

end

function AccountLogin_OnKeyDown(this, key)
	if ( key == "ESCAPE" ) then
		AccountLogin_Exit();
	end
end

function AccountLogin_OnKeyUp(this, key)

end

function AccountLogin_OnMouseDown(this, key)

end

function AccountLogin_OnMouseUp(this, key)

end

function AccountLogin_OnUpdate(this, elapsedTime)
	if ( AccountLogin.update ) then
		AccountLogin.update = AccountLogin.update + elapsedTime;
		Alpha = ( AccountLogin.update - ACCOUNTLOGIN_FADEIN_TIME1 ) / ACCOUNTLOGIN_FADEIN_TIME2;
		if( Alpha < 0 )then
			Alpha = 0;
		elseif( Alpha > 1.0 )then
			Alpha = 1.0;
		end
		AccountLogin:SetAlpha( Alpha );

		if ( Alpha >= 1.0 ) then
			AccountLogin.update = nil;
		end
	end
end

fastLoginLoggedInUser = "" -- rv

function AccountLogin_Login()

	if ( fastLoginAutoLogin and ( not fastLoginTriedOnce ) ) then
		fastLoginLoggedInUser = fastLoginUser -- rv
		DefaultServerLogin(fastLoginUser, fastLoginPass);
	else
		fastLoginLoggedInUser = AccountLoginAccountEdit:GetText() -- rv
		DefaultServerLogin(AccountLoginAccountEdit:GetText(), AccountLoginPasswordEdit:GetText());
		AccountLoginPasswordEdit:SetText("");
	end

	AccountLoginAccountEdit:ClearFocus();
	AccountLoginPasswordEdit:ClearFocus();
end

function AccountLogin_FocusPassword()
	AccountLoginPasswordEdit:SetFocus();
end

function AccountLogin_FocusAccountName()
	AccountLoginAccountEdit:SetFocus();
end

function AccountLoginPasswordEdit_OnGained(this, arg1)

end

function AccountLoginPasswordEdit_SetText(text)
	AccountLoginPasswordEdit:InsertChar(text);
end

function AccountLogin_Exit()
	QuitGame();
end

function AccountLogin_OnLoad()
	CustomLogin_OnLoad();
	local file = "Interface\\Login\\Logo\\"..GetImageLocation().."\\RA_LOGO";
	AccountLogin.update = nil;
	AccountLoginVersion:SetText(GetVersion());
	AccountLoginLogo:SetTexture(file);
end

function AccountLogin_Show()
	AccountLogin.update = 0;
	AccountLogin:SetAlpha(0);
	AccountLogin:Show();
end

local function ReturnLoginID(ID)
	if		( ID == 1 )	then	return CustomLogin.Account1.UserName, CustomLogin.Account1.Password, 1 ;
	elseif	( ID == 2 )	then	return CustomLogin.Account2.UserName, CustomLogin.Account2.Password, 2;
	elseif	( ID == 3 )	then	return CustomLogin.Account3.UserName, CustomLogin.Account3.Password, 3;
	elseif	( ID == 4 )	then	return CustomLogin.Account4.UserName, CustomLogin.Account4.Password, 4;
	elseif	( ID == 5 )	then	return CustomLogin.Account5.UserName, CustomLogin.Account5.Password, 5;
	elseif	( ID == 6 )	then	return CustomLogin.Account6.UserName, CustomLogin.Account6.Password, 6;
	elseif	( ID == 7 )	then	return CustomLogin.Account7.UserName, CustomLogin.Account7.Password, 7;
	elseif	( ID == 8 )	then	return CustomLogin.Account8.UserName, CustomLogin.Account8.Password, 8;
	elseif	( ID == 9 )	then	return CustomLogin.Account9.UserName, CustomLogin.Account9.Password, 9;
	elseif	( ID == 10 )	then	return CustomLogin.Account10.UserName, CustomLogin.Account10.Password, 10;
	elseif	( ID == 11 )	then	return CustomLogin.Account11.UserName, CustomLogin.Account11.Password, 11;
	elseif	( ID == 12 )	then	return CustomLogin.Account12.UserName, CustomLogin.Account12.Password, 12;
	elseif	( ID == 13 )	then	return CustomLogin.Account13.UserName, CustomLogin.Account13.Password, 13;
	elseif	( ID == 14 )	then	return CustomLogin.Account14.UserName, CustomLogin.Account14.Password, 14;
	elseif	( ID == 15 )	then	return CustomLogin.Account15.UserName, CustomLogin.Account15.Password, 15;
	elseif	( ID == 16 )	then	return CustomLogin.Account16.UserName, CustomLogin.Account16.Password, 16;
	elseif	( ID == 17 )	then	return CustomLogin.Account17.UserName, CustomLogin.Account17.Password, 17;
	elseif	( ID == 18 )	then	return CustomLogin.Account18.UserName, CustomLogin.Account18.Password, 18;
	elseif	( ID == 19 )	then	return CustomLogin.Account19.UserName, CustomLogin.Account19.Password, 19;
	elseif	( ID == 20 )	then	return CustomLogin.Account20.UserName, CustomLogin.Account20.Password, 20;
	elseif	( ID == 21 )	then	return CustomLogin.Account21.UserName, CustomLogin.Account21.Password, 21;
	elseif	( ID == 22 )	then	return CustomLogin.Account22.UserName, CustomLogin.Account22.Password, 22;
	elseif	( ID == 23 )	then	return CustomLogin.Account23.UserName, CustomLogin.Account23.Password, 23;
	elseif	( ID == 24 )	then	return CustomLogin.Account24.UserName, CustomLogin.Account24.Password, 24;
	elseif	( ID == 25 )	then	return CustomLogin.Account25.UserName, CustomLogin.Account25.Password, 25;
	elseif	( ID == 26 )	then	return CustomLogin.Account26.UserName, CustomLogin.Account26.Password, 26;
	elseif	( ID == 27 )	then	return CustomLogin.Account27.UserName, CustomLogin.Account27.Password, 27;
	elseif	( ID == 28 )	then	return CustomLogin.Account28.UserName, CustomLogin.Account28.Password, 28;
	elseif	( ID == 29 )	then	return CustomLogin.Account29.UserName, CustomLogin.Account29.Password, 29;
	elseif	( ID == 30 )	then	return CustomLogin.Account30.UserName, CustomLogin.Account30.Password, 30;
	elseif	( ID == 31 )	then	return CustomLogin.Account31.UserName, CustomLogin.Account31.Password, 31;
	elseif	( ID == 32 )	then	return CustomLogin.Account32.UserName, CustomLogin.Account32.Password, 32;
	elseif	( ID == 33 )	then	return CustomLogin.Account33.UserName, CustomLogin.Account33.Password, 33;
	elseif	( ID == 34 )	then	return CustomLogin.Account34.UserName, CustomLogin.Account34.Password, 34;
	elseif	( ID == 35 )	then	return CustomLogin.Account35.UserName, CustomLogin.Account35.Password, 35;
	elseif	( ID == 36 )	then	return CustomLogin.Account36.UserName, CustomLogin.Account36.Password, 36;
	elseif	( ID == 37 )	then	return CustomLogin.Account37.UserName, CustomLogin.Account37.Password, 37;
	elseif	( ID == 38 )	then	return CustomLogin.Account38.UserName, CustomLogin.Account38.Password, 38;
	elseif	( ID == 39 )	then	return CustomLogin.Account39.UserName, CustomLogin.Account39.Password, 39;
	elseif	( ID == 40 )	then	return CustomLogin.Account40.UserName, CustomLogin.Account40.Password, 40;
	end
end

function CustomLogin_OnLoad()
	for i=1, 40 do
		local Name, Pass = ReturnLoginID(i);
		if ( ( Name ~= nil ) and ( Name ~= "" ) and ( Name ~= " " ) ) then
			button = getglobal("CustomLoginButton"..i);
			button:SetText(Name);
		else
			button = getglobal("CustomLoginButton"..i);
			button:Hide();
		end
	end
end


function CustomLoginButton_OnClick(ID)
	local Name, Pass, LocalLogID = ReturnLoginID(ID);
	AccountLoginAccountEdit:SetText(Name);
	AccountLoginPasswordEdit:SetText(Pass);
	LogID = LocalLogID;
	AccountLogin_Login();
end

function ChangeChar(toontoload, acctoload, channel)
	if channel ~= nil then
		UserSelectedChannel = channel
	end

	if acctoload == nil or toontoload == nil then
		acctoload = LogID
	end

	if toontoload == nil then -- User wants to load next character
		toontoload = CHARACTER_SELECT.selectedIndex
		LoginNextToon = true
	else
		ChangeCharRelog=true
	end

	if type(acctoload) == "string" then
		-- Find acctoload number
		local found = false
		for account, details in pairs(CustomLogin) do
			if details.UserName == acctoload then
				acctoload = tonumber(string.match(account,"Account(%d*)"))
				found = true
				break
			end
		end
		-- account name not found
		if not found then
			return
		end
	end

	swappingChar = true

	fastLoginChrSel = toontoload
	CHARACTER_SELECT.selectedIndex = toontoload
	LogID = acctoload
	fastLoginUser = CustomLogin["Account"..acctoload].UserName
	fastLoginPass = CustomLogin["Account"..acctoload].Password
	DisconnectFromServer()
	DefaultServerLogin(fastLoginUser,fastLoginPass)
end
